﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProjectByldozerHard;

public partial class FormByldozer : Form
{


    /// <summary>
    /// поле объект для прорисовки объекта
    /// </summary>
    private DrawningByldozer? _drawingByldozer;

    public FormByldozer()
    {
        InitializeComponent();
    }
    private void Draw()
    {
        if (_drawingByldozer == null)
        {
            return;
        }

        Bitmap bmp = new(pictureBoxByldozer.Width, pictureBoxByldozer.Height);
        Graphics gr = Graphics.FromImage(bmp);
        _drawingByldozer.DrawTransport(gr);
        pictureBoxByldozer.Image = bmp;
    }

    /// <summary>
    /// обработка кнопки создать
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void ButtonCreat_Click(object sender, EventArgs e)
    {
        Random random = new();
        _drawingByldozer = new DrawningByldozer();
        _drawingByldozer.Init(random.Next(100, 300), random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)) , random.Next(1, 4) * 2,
            pictureBoxByldozer.Width, pictureBoxByldozer.Height);

        _drawingByldozer.SetPosition(random.Next(10, 100), random.Next(10, 100));
        _drawingByldozer.Rink.KatNum = (int)numericUpDownrinkByldozer.Value;
        Draw();
    }

    /// <summary>
    /// перемещение объекта
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void ButtonMove_Click(object sender, EventArgs e)
    {
        if (_drawingByldozer == null)
        {
            return;
        }

        string name = ((Button)sender)?.Name ?? string.Empty;

        switch (name)
        {
            case "buttonUp":
                _drawingByldozer.MoveTransport(DirectionType.Up);
                break;
            case "buttonDown":
                _drawingByldozer.MoveTransport(DirectionType.Down);
                break;
            case "buttonLeft":
                _drawingByldozer.MoveTransport(DirectionType.Left);
                break;
            case "buttonRight":
                _drawingByldozer.MoveTransport(DirectionType.Right);
                break;
        }

        Draw();
    }


}


